//
//  DDSDocument.swift
//  DocumentDefaultsSample
//
//  Created by narita on 2019/05/28.
//  Copyright © 2019 narita. All rights reserved.
//

import Cocoa

// BORDER_COLOR
// FILL_COLOR
// BORDER_WIDTH
// MINTLHTMLColor2Color

class DDSDocument: NSPersistentDocument
{
    // MARK: - class methods

    override class var autosavesInPlace: Bool
    {
        return true
    }

    // MARK: - init methods

    override init()
    {
        super.init()
    }

    // MARK: - dealloc
    
    // MARK: - NSCopying, hash, isEqual:
    
    // MARK: - NSCoding methods
    
    // MARK: - restorableState methods
    
    // MARK: - life cycle methods
    
    // MARK: - action methods

    @IBAction func makeNewWindow(_ sender: NSObject!)
    {
        let theWindowController = self.makeNewWindowController()
        
        theWindowController?.showWindow(sender)
    }

    // MARK: - event handling methods
    
    // MARK: - drawing methods
    
    // MARK: - delegate/datasource methods

    // MARK: - accessor methods (in pairs)
    
    @objc lazy var documentDefaults: MINTLDocumentDefaults? =
    {
        // この"HeaderNode"の名前はCoreDataのスキーマで設定した名前
       return MINTLDocumentDefaults(document: self, entityName: "HeaderNode")
    }()
    
    // MARK: - Utility methods
    
    func makeNewWindowController() -> NSWindowController?
    {
        let storyboard = NSStoryboard(name: "DDSWindowController", bundle: nil)
        
        let theWindowController = storyboard.instantiateInitialController() as! NSWindowController
        
        self.addWindowController(theWindowController)
        
        if let theContentsViewController = theWindowController.contentViewController
        {
            theContentsViewController.representedObject = self
        }
        
        return theWindowController
    }
    
    override func makeWindowControllers()
    {
        self.makeNewWindow(self)
    }

}
